#include "stdafx.h"

#include "map_wl.h"

#if !defined(_M_I86LM) & !defined(_M_I86CM)
	#error Sorry, the CMapWordToLong class in MAP_WL.CPP requires large (or compact) model!
#endif

IMPLEMENT_DYNAMIC(CMapWordToLong, CMapWordToPtr)

#ifdef _DEBUG
	// Define this to get debugging trace output
	// #define DEBUG
	#undef THIS_FILE
	static char BASED_CODE THIS_FILE[] = __FILE__;
	#define new DEBUG_NEW
#endif


CMapWordToLong::CMapWordToLong(int nBlockSize) : CMapWordToPtr(nBlockSize)
{
}


CMapWordToLong::~CMapWordToLong(void)
{
}


void CMapWordToLong::GetNextAssoc(POSITION& pos, WORD& rKey, long &rValue) const
{
	// Copy code from CMapWordToPtr::GetNextAssoc()
	ASSERT_VALID(this);
	ASSERT(m_pHashTable != NULL);  // never call on empty map

	CAssoc *pAssocRet = (CAssoc*)pos;
	ASSERT(pAssocRet != NULL);

	if (pAssocRet == (CAssoc *)MAP_WL_BEFORE_START_POSITION)
		{
		// find the first association
		for (UINT nBucket = 0; nBucket < m_nHashTableSize; nBucket++)
			if ((pAssocRet = m_pHashTable[nBucket]) != NULL)
				break;
		ASSERT(pAssocRet != NULL);  // must find something
		}

	// find next association
	ASSERT(AfxIsValidAddress(pAssocRet, sizeof(CAssoc)));
	CAssoc *pAssocNext;
	if ((pAssocNext = pAssocRet->pNext) == NULL)
		{
		// go to next bucket
		for (UINT nBucket = pAssocRet->nHashValue + 1;
		  nBucket < m_nHashTableSize; nBucket++)
			if ((pAssocNext = m_pHashTable[nBucket]) != NULL)
				break;
		}

	pos = (POSITION)pAssocNext;

	// fill in return data
	rKey = pAssocRet->key;
	rValue = (long)pAssocRet->value;

	return;
}
